# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ...core.datetime_utils import serialize_datetime
from ...core.pydantic_utilities import deep_union_pydantic_dicts, pydantic_v1
from .trade_traversal_path import TradeTraversalPath


class UpstreamTradeTraversalResponse(pydantic_v1.BaseModel):
    """
    Examples
    --------
    from sayari import (
        HsCodeWithDescription,
        TradeTraversalEntity,
        TradeTraversalPath,
        TradeTraversalPathSegment,
        TradeTraversalProduct,
        UpstreamTradeTraversalResponse,
    )

    UpstreamTradeTraversalResponse(
        data=[
            TradeTraversalPath(
                source="ESkH7J-UCRfY5t0_JXIH3w",
                target=TradeTraversalEntity(
                    id="BAQGiWn9riAG10h4NuK_9w",
                    type="company",
                    label="TEXMARK CHEMICALS INC",
                    countries=["USA"],
                    risk=["forced_labor_xinjiang_origin_subtier"],
                ),
                path=[
                    TradeTraversalPathSegment(
                        entity=TradeTraversalEntity(
                            id="ESkH7J-UCRfY5t0_JXIH3w",
                            type="company",
                            label="ACUMEN HOUSEWARE INDUSTRY VIETNAM CO LTD",
                            countries=["VNM"],
                            risk=[],
                        ),
                        products=[
                            TradeTraversalProduct(
                                hs_code=HsCodeWithDescription(
                                    code="3204",
                                    description="Synthetic dyes & agents",
                                ),
                                min_date="2023-04-01",
                                max_date="2024-03-27",
                                arrival_countries=["VNM"],
                                departure_countries=["IND"],
                            )
                        ],
                    ),
                    TradeTraversalPathSegment(
                        entity=TradeTraversalEntity(
                            id="A84F35yJ_3FT_hVzD9EzAw",
                            type="company",
                            label="TOYO INK INDIA PRIVATE LIMITED",
                            countries=["IND"],
                            risk=[
                                "forced_labor_sheffield_hallam_university_reports_origin_subtier",
                                "forced_labor_uflpa_origin_subtier",
                                "forced_labor_xinjiang_origin_subtier",
                            ],
                        ),
                        products=[
                            TradeTraversalProduct(
                                hs_code=HsCodeWithDescription(
                                    code="3206",
                                    description="Other dyes & colorants",
                                ),
                                min_date="2023-03-01",
                                max_date="2024-02-12",
                                arrival_countries=["IND"],
                                departure_countries=["CHN"],
                            )
                        ],
                    ),
                ],
            )
        ],
    )
    """

    status: typing.Optional[int] = None
    success: typing.Optional[bool] = None
    message: typing.Optional[str] = None
    data: typing.List[TradeTraversalPath]

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults_exclude_unset: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        kwargs_with_defaults_exclude_none: typing.Any = {"by_alias": True, "exclude_none": True, **kwargs}

        return deep_union_pydantic_dicts(
            super().dict(**kwargs_with_defaults_exclude_unset), super().dict(**kwargs_with_defaults_exclude_none)
        )

    class Config:
        frozen = True
        smart_union = True
        extra = pydantic_v1.Extra.allow
        json_encoders = {dt.datetime: serialize_datetime}
